//==============================================================================================
#include "pcap.h"

char* myservicename = "traflogger";
const char *filecharsrestricted = ".\"/\\[]:;|=,*? ";
char* errorlogfile = "error.log";
char* archdir = "archive";
//char* httplogfile = "httplog";
//FILE * httplog;
SYSTEMTIME curtime;
#define MAX_PERIOD_IPS 1000

int time_period = 5; //seconds of minimum logged time period
int max_err_log_sz = 34000; //maximum error.log file size
typedef struct{
	int month;
	int day;
	int hour;
	int minute;
}ymdhm;

ymdhm arch_at = {-1,1,0,5}; //archive at 1-th 00:05 every month

/* 4 bytes IP address */
typedef struct ip_address{
    u_char byte1;
    u_char byte2;
    u_char byte3;
    u_char byte4;
}ip_address;

/* IPv4 header */
typedef struct ip_header{
    u_char  ver_ihl;        // Version (4 bits) + Internet header length (4 bits)
    u_char  tos;            // Type of service 
    u_short tlen;           // Total length 
    u_short identification; // Identification
    u_short flags_fo;       // Flags (3 bits) + Fragment offset (13 bits)
    u_char  ttl;            // Time to live
    u_char  proto;          // Protocol
    u_short crc;            // Header checksum
    u_int   saddr;          // Source address
    u_int   daddr;          // Destination address
    u_int   op_pad;         // Option + Padding
}ip_header;

/* UDP header*/
typedef struct udp_header{
    u_short sport;          // Source port
    u_short dport;          // Destination port
    u_short len;            // packet length
    u_short crc;            // Checksum
}udp_header;

/* TCP header*/
typedef struct tcp_header{
    u_short sport;          // Source port
    u_short dport;          // Destination port
    u_int   seq_n;          // Sequence Number
    u_int   ack_n;          // Acknowledgment Number
	u_char  data;           // Data Offset (number of DWORDs in TCP header)
	u_char  flags;          // Flags
	u_short window;         // Window
	u_short checksum;       // Checksum
	u_short urgent;         // Urgent Pointer
	u_int   options;        // options
}tcp_header;

/* tempstruct header*/
typedef struct period_e{
    u_int ips;             // source ip
    u_int ipd;             // destination ip
    u_short ports;         // Source port
    u_short portd;         // Destination port
    u_int proto;           // higher protocol
    u_int size;            // sum of packet sizes
    u_int packets;         // amount of packets
}period_e;

/*structure, holding queue of packet descriptions(period_e) for the time period*/
typedef struct period_s{
	u_int time;
	u_int stored;
	period_e elem[MAX_PERIOD_IPS];
	period_s *next;
}period_s;

/* structure to pass to handler procedure */
typedef struct stpth{
	period_s *p;
	HANDLE f;
}stpth;

/* prototype of the packet handler */
void packet_handler(u_char *param, const struct pcap_pkthdr *header, const u_char *pkt_data);

/* service supply functions */
BOOL sermustexit = FALSE;
SERVICE_STATUS_HANDLE serstathndl;
SERVICE_STATUS serstat;


int InstallThisAsService();
int UninstallThisService();
void WINAPI ServiceProc(DWORD argc,LPTSTR *argv);
void WINAPI service0handler(DWORD opcode);
const	SERVICE_TABLE_ENTRY servicetable[2] = {{myservicename,ServiceProc},
											{NULL,NULL}};

int printerrtime()
{
	GetLocalTime(&curtime);
	return fprintf(stderr,"%u-%2.2u-%2.2u %2.2u:%2.2u:%2.2u\n",
		curtime.wYear,curtime.wMonth,curtime.wDay,curtime.wHour,curtime.wMinute,curtime.wSecond);
}

int readinifile()
{
	char s[256];
	FILE *f;
	int i;
	if(NULL ==(f = fopen("traflogger.ini","r"))){printf("traflogger.ini opening failed,error #%d\n",GetLastError()); return 0;}
	while (NULL != fgets(s,255,f))
	{
		printf("ini string:%s\n",s);
		if(!strnicmp("time_period",s,11)) //number
		{
			i = 11;
			while((s[i]!=0)&&(s[i]==' '))i++;
			if((s[i]!=0)&&((s[i]>='0')&&(s[i]<='9')))time_period = 0;
			while((s[i]!=0)&&((s[i]>='0')&&(s[i]<='9'))){time_period = time_period * 10 + (s[i] - '0'); i++;}
		}
		else if(!strnicmp("max_err_log_sz",s,14)) //number
		{
			i = 14;
			while((s[i]!=0)&&(s[i]==' '))i++;
			if((s[i]!=0)&&((s[i]>='0')&&(s[i]<='9')))max_err_log_sz = 0;
			while((s[i]!=0)&&((s[i]>='0')&&(s[i]<='9'))){max_err_log_sz = max_err_log_sz * 10 + (s[i] - '0'); i++;}
		}
		else if(!strnicmp("devlog_arch_at",s,14)) //sequence of numbers
		{
			i = 14;
			while((s[i]!=0)&&(s[i]==' '))i++;
			if((s[i]!=0)&&((s[i]>='0')&&(s[i]<='9')))
			{arch_at.day = arch_at.hour = arch_at.month = -1; arch_at.minute = 0;} else goto daae;
			while((s[i]!=0)&&((s[i]>='0')&&(s[i]<='9'))){arch_at.minute = arch_at.minute * 10 + (s[i] - '0'); i++;}
			while((s[i]!=0)&&(s[i]==' '))i++;
			if((s[i]!=0)&&((s[i]>='0')&&(s[i]<='9'))) arch_at.hour = 0; else goto daae;
			while((s[i]!=0)&&((s[i]>='0')&&(s[i]<='9'))){arch_at.hour = arch_at.hour * 10 + (s[i] - '0'); i++;}
			while((s[i]!=0)&&(s[i]==' '))i++;
			if((s[i]!=0)&&((s[i]>='0')&&(s[i]<='9'))) arch_at.day = 0; else goto daae;
			while((s[i]!=0)&&((s[i]>='0')&&(s[i]<='9'))){arch_at.day = arch_at.day * 10 + (s[i] - '0'); i++;}
			while((s[i]!=0)&&(s[i]==' '))i++;
			if((s[i]!=0)&&((s[i]>='0')&&(s[i]<='9'))) arch_at.month = 0; else goto daae;
			while((s[i]!=0)&&((s[i]>='0')&&(s[i]<='9'))){arch_at.month = arch_at.month * 10 + (s[i] - '0'); i++;}
daae:		;
		}
	}
	fclose(f);
	return 0;
}

int main(int argc,char* argv[])
{
	FILE * errfile; //   stderr
	LPVOID lpMsgBuf; //    
	int i; //   
	char s[256]; //    
// -  -    
	if((argc == 2) && (!strcmp(argv[1],"/install")))
		return(InstallThisAsService());
//   
	if((argc == 2) && (!strcmp(argv[1],"/uninstall")))
		return(UninstallThisService());
//    . 
	if(i = GetModuleFileName(NULL,s,256))
	{
		for(;(s[i]!='\\')&&(i>0);i--);
		if(i){s[i] = 0; SetCurrentDirectory(s);}
	}
	else
	{
		fprintf(stderr,"error %d occured, when getting module filename\n",GetLastError());
		fflush(stderr);
	}
// stderr      errorlogfile
	if(NULL == (errfile = freopen(errorlogfile,"at",stderr)))
	{
		printf("can't open file %s for errors, lasterror = %d",errorlogfile,GetLastError());
		return 0;
	}
//   http
//	if(NULL == (httplog = fopen(httplogfile,"ab")))
//	{
//		fprintf(stderr,"can't open file %s for http log, lasterror = %d",httplogfile,GetLastError());
//		return 0;
//	}
// -   
	printerrtime();	fprintf(stderr,"program started\n"); fflush(stderr);
//  
	readinifile();
//  (- )
	if(0 == (i = StartServiceCtrlDispatcher(servicetable)))
	{
		i = GetLastError();
		if(i == ERROR_FAILED_SERVICE_CONTROLLER_CONNECT) //tipically, when program ran from console, not SCM
		{
			printf("This program runs as service \"%s\",\n\tto install service, specify /install,\n\tto uninstall, specify /uninstall\n",myservicename);
		}
		else
		{
			printerrtime();
			if (FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
			    NULL, i, 0, (LPTSTR) &lpMsgBuf, 0, NULL ))
			fprintf(stderr,"error %d occured when starting service control dispatcher:\n%s\n",i,lpMsgBuf);
			else fprintf(stderr,"error %d occured when starting service control dispatcher\n",i);
			fflush(stderr);
			LocalFree( lpMsgBuf );
		}
	}
	return(0);
}

/* the thread created from service entry point for every found adapter */
DWORD WINAPI tp(LPVOID lpParameter)
{
	char s[256],s1[256];
	int threadmustarch = 0; //flag of that this interface log must be archived
	HANDLE fdh;
	WIN32_FIND_DATA fd; //structure used to check for exsisting archdir - archive directory
	struct tm *ftm; //time, taken from devlog file by localtime() function
	u_int ftm_i; //time, taken from devlog file
	int tb[5],ta[5]; //time begin and time archive - [0]..[4] - year, month, day, hour, minute
	int i,j,k;
	SYSTEMTIME syst;
	period_s p,temp; //queue of log elementary structure arrays
	stpth knep; //structure to pass to handler
	p.next = &temp;	knep.p = temp.next = &p;     //make two switchable period structures
	p.stored = 0; temp.stored = 0;
	p.time = 0; temp.time = 0;
    pcap_t *adhandle; //handle of opened interface
    char errbuf[PCAP_ERRBUF_SIZE]; //   pcap
    /* Open the adapter */
    if ( NULL == (adhandle = pcap_open_live((char *)lpParameter, // name of the device
                             65536,     // portion of the packet to capture. 
                                        // 65536 grants that the whole packet will be captured on all the MACs.
                             1,         // promiscuous mode
                             1000,      // read timeout (ms)
                             errbuf     // error buffer
                             ) ) )
    {
		printerrtime();
        fprintf(stderr,"\nUnable to open the adapter. %s is not supported by WinPcap\n",(char *)lpParameter); fflush(stderr);
        return -1;
    }
    /* Check the link layer. We support only Ethernet for simplicity. */
    if(pcap_datalink(adhandle) != DLT_EN10MB)
    {
		printerrtime();
        fprintf(stderr,"This program works only on Ethernet interfaces.\n"); fflush(stderr);
        return -1;
    }
	//make s[] appropriate filename for device with name lpParameter[]
	for(i=0,j=0;((char *)lpParameter)[i]!=0;i++)
	{
		for(k = 0;(filecharsrestricted[k] != 0) && (((char *)lpParameter)[i] != filecharsrestricted[k]);k++);
		if(filecharsrestricted[k] == 0){s[j] = ((char *)lpParameter)[i]; j++;}
		else{s[j] = '_'; j++;}
	}
	s[j] = 0;
afterarch:
	//open <new> devicelog file
	if(INVALID_HANDLE_VALUE == (knep.f = CreateFile(s,GENERIC_WRITE | GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_ALWAYS,0,0)))
	{
		printerrtime();
		fprintf(stderr,"can't open file %s for writing, error #%d\n",s,GetLastError()); fflush(stderr);
		return -1;
	}
	/*get the devlog begin time or current time, if file is empty*/
	j = ReadFile(knep.f,&ftm_i,4,(u_long *)&i,NULL);
	if(j && i)
	{
		if(NULL == (ftm = localtime((long *)&ftm_i)))fprintf(stderr,"strange, localtime of %d failed\n",ftm_i);
		else 
		{tb[0] = ftm->tm_year + 1900; tb[1] = ftm->tm_mon + 1; tb[2] = ftm->tm_mday; tb[3] = ftm->tm_hour; tb[4] = ftm->tm_min;}
	}
	else
	{
		GetLocalTime(&syst);
		tb[0] = syst.wYear; tb[1] = syst.wMonth; tb[2] = syst.wDay; tb[3] = syst.wHour; tb[4] = syst.wMinute;
	}
	fprintf(stderr,"begin date is set to %04d-%02d-%02d %02d:%02d\n",tb[0],tb[1],tb[2],tb[3],tb[4]);
	/*and set corresponding time to archive*/
	ta[0] = tb[0]; j = 0;
	if(arch_at.month == -1){ta[1] = tb[1]; j = 1;} else ta[1] = arch_at.month;
	if(arch_at.day == -1){ta[2] = tb[2]; j = 2;} else ta[2] = arch_at.day;
	if(arch_at.hour == -1){ta[3] = tb[3]; j = 3;} else ta[3] = arch_at.hour;
	if(arch_at.minute == -1){ta[4] = tb[4]; j = 4;} else ta[4] = arch_at.minute;
	if( (((((ta[1] * 12)+ta[2])*31)+ta[3])*60+ta[4]) <= (((((tb[1] * 12)+tb[2])*31)+tb[3])*60+tb[4]) )ta[j]++;
	fprintf(stderr,"arch date is set to %04d-%02d-%02d %02d:%02d\n",ta[0],ta[1],ta[2],ta[3],ta[4]);
	/*go to end of file to append*/
	SetFilePointer(knep.f,0,NULL,FILE_END);
    fprintf(stderr,"listening on %s\n", (char *)lpParameter); fflush(stderr);
    /* start the capture */
	while(!sermustexit)
	{
		GetLocalTime(&syst);
		if( ((((((ta[0]*12+ta[1])*31)+ta[2])*24)+ta[3])*60+ta[4]) <= 
			((((((syst.wYear*12+syst.wMonth)*31)+syst.wDay)*24)+syst.wHour)*60+syst.wMinute) )
			threadmustarch = 1;
		pcap_dispatch(adhandle, 1, packet_handler, (u_char *)&knep);
		if(threadmustarch)
		{
			CloseHandle(knep.f);
			fdh = FindFirstFile(archdir,&fd);
			if((NULL != fdh) && (fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
			{
				sprintf(s1,"%s\\%02d%02d-%02d%02d",archdir,syst.wMonth,syst.wDay,syst.wHour,syst.wMinute);
				j = strlen(s1);
				for(i = 0;i<(255-j);i++)s1[i+j]=s[i]; s1[255] = 0;
			}
			else
			{
				fprintf(stderr,"no directory \"%s\" exist, trying to create .. ",archdir);
				if(CreateDirectory(archdir,NULL))
				{
					fprintf(stderr,"ok\n"); 
					sprintf(s1,"%s\\%02d%02d-%02d%02d",archdir,syst.wMonth,syst.wDay,syst.wHour,syst.wMinute);
				}
				else
				{
					fprintf(stderr,"failed with err#%d\n",GetLastError());
					sprintf(s1,"%02d%02d-%02d%02d",syst.wMonth,syst.wDay,syst.wHour,syst.wMinute);
				}
				j = strlen(s1);
				for(i = 0;i<(255-j);i++)s1[i+j]=s[i]; s1[255] = 0;
			}
			fprintf(stderr,"trying to move %s to %s ..",s,s1);
			if(MoveFile(s,s1))fprintf(stderr,"ok\n"); else fprintf(stderr,"faild with error %d",GetLastError());
			threadmustarch = 0;
			goto afterarch;
		}
	}
	CloseHandle(knep.f);
	return 0;
}
//   
void WINAPI ServiceProc(DWORD argc,LPTSTR *argv)
{
	serstathndl = RegisterServiceCtrlHandler(myservicename,&service0handler);
	serstat.dwCheckPoint = 0;
	serstat.dwControlsAccepted = SERVICE_ACCEPT_STOP;
	serstat.dwCurrentState = SERVICE_RUNNING;
	serstat.dwServiceSpecificExitCode = 0;
	serstat.dwServiceType = SERVICE_WIN32_SHARE_PROCESS;
	serstat.dwWaitHint = 2000;
	serstat.dwWin32ExitCode = 0;
	LPVOID lpMsgBuf;
	SetServiceStatus(serstathndl,&serstat);
    pcap_if_t *alldevs;
    pcap_if_t *d;
    int i;
    char errbuf[PCAP_ERRBUF_SIZE];
	HANDLE threads[16];
	DWORD tids[16];
    /* Retrieve the device list */
    if (pcap_findalldevs(&alldevs, errbuf) == -1)
    {
        fprintf(stderr,"Error in pcap_findalldevs: %s\n", errbuf); fflush(stderr);
        exit(1);
    }
    /* Print the list */
	i = 0;
    for(d=alldevs; d && (i<15); d=d->next)
    {
		//       
		fprintf(stderr,"%s", d->name);
        if (d->description)
            fprintf(stderr," (%s)\n", d->description);
        else
            fprintf(stderr," (No description available)\n");
		//    
		if(NULL == (threads[i] = CreateThread(NULL,0,tp,d->name,0,tids+i)))fprintf(stderr,"thread creation failed err# %d ",GetLastError());
		else i++;
		fflush(stderr);
    }
	// 15       
	if(d)fprintf(stderr,"if you have more than 15 net interfaces - use another compilation of traflogger\n");
    if(i==0)
    {
        fprintf(stderr,"\nNo interfaces found! Make sure WinPcap is installed.\n"); fflush(stderr);
        return;
    }
	//    
    if(WAIT_FAILED == (WaitForMultipleObjectsEx(i,threads,true,INFINITE,false)))
	{
		printerrtime();
		i = GetLastError();
		if (FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
		    NULL, i, 0, (LPTSTR) &lpMsgBuf, 0, NULL ))
		fprintf(stderr,"error %d occured when starting service control dispatcher:\n%s\n",i,lpMsgBuf);
		else fprintf(stderr,"wait failed! error# %d \n",i);
		fflush(stderr);
		LocalFree( lpMsgBuf );
	}
    /* At this point, we don't need any more the device list. Free it */
    pcap_freealldevs(alldevs);
    
    return;
}

/* Callback function invoked by libpcap for every incoming packet */
void packet_handler(u_char *param, const struct pcap_pkthdr *header, const u_char *pkt_data)
{
	stpth *par = (stpth *)param; //stpth - Structure To Pass To Handler
	char *s = (char *)&par->p->elem;
//	char tstr[256];
	u_int i;
	u_long j;
    ip_header *ih;
    udp_header *uh;
    u_int ip_len;
    u_int sport,dport,flags_fo;
	unsigned short sb = ntohs(*(unsigned short *)(pkt_data + 12));
	if(sb != 0x0800) return;  //capture only ip encapsulating type ethernet packets

    ih = (ip_header *) (pkt_data + 14); //length of ethernet header

    ip_len = (ih->ver_ihl & 0xf) * 4;
    uh = (udp_header *) ((u_char*)ih + ip_len);
    sport = ntohs( uh->sport );
    dport = ntohs( uh->dport );
	flags_fo = ntohs( ih->flags_fo );
	//if fragment offset != 0, or protocol is neither udp nor tcp - make ports to zero
	if((flags_fo & 0x1FFF) || ((ih->proto != 6) && (ih->proto != 17)))sport = dport = 0; 
	i = 0;
	//try do decode http request
//	if(((ih->proto == 6)&&(dport == 80))&&(header->caplen > 62))
//	{
//		sprintf(tstr,"\n%d.%d.%d.%d\t%d.%d.%d.%d\n",*(u_char *)(&ih->saddr),*((u_char *)(&ih->saddr)+1),*((u_char *)(&ih->saddr)+2),*((u_char *)(&ih->saddr)+3),
//				*((u_char *)(&ih->daddr)),*((u_char *)(&ih->daddr)+1),*((u_char *)(&ih->daddr)+2),*((u_char *)(&ih->daddr)+3));
//		fwrite(tstr,strlen(tstr),1,httplog);
//		fwrite(pkt_data + 54,header->caplen - 54,1,httplog);
//	}
	while(i < par->p->stored)
	{
		if(par->p->elem[i].ips == ih->saddr)
			if(par->p->elem[i].ipd == ih->daddr)
				if(par->p->elem[i].ports == sport)
					if(par->p->elem[i].proto == ih->proto)
					{
						par->p->elem[i].packets++;
						par->p->elem[i].size += ntohs(ih->tlen);
						break;
					}
		i++;
	}
	if(i == par->p->stored)
	{
		par->p->stored++;
		par->p->elem[i].ips = ih->saddr;
		par->p->elem[i].ipd = ih->daddr;
		par->p->elem[i].ports = sport;
		par->p->elem[i].portd = dport;
		par->p->elem[i].proto = ih->proto;
		par->p->elem[i].packets = 1;
		par->p->elem[i].size = ntohs(ih->tlen);
	}
//	if(i > par->p->stored){fprintf(stderr,"very strange! i exceeds stored\n"); fflush(stderr);}
	// write to file when time period elapses or structure fulfilled
	if( ((u_int)header->ts.tv_sec >= par->p->time) || (par->p->stored == MAX_PERIOD_IPS) )
	{
		//prepare structure
		//write to file
		if(!WriteFile(par->f,&header->ts.tv_sec,4,&j,NULL))
		{printerrtime(); fprintf(stderr,"write error #%d\n",GetLastError()); fflush(stderr);}
		WriteFile(par->f,&par->p->stored,2,&j,NULL);
		WriteFile(par->f,&par->p->elem,par->p->stored * sizeof(period_e),&j,NULL);
		FlushFileBuffers(par->f);
		//switch
		//prepare new structure
		par->p->time = (u_int)header->ts.tv_sec + time_period;
		par->p->stored = 0;
	}
}

void WINAPI service0handler(DWORD opcode)
{
	switch(opcode)
	{
		case SERVICE_CONTROL_STOP:
			serstat.dwCurrentState = SERVICE_STOPPED;
			sermustexit = TRUE;
			break;
		default:
			break;
	}
	SetServiceStatus(serstathndl,&serstat);
	return;
}

int InstallThisAsService()
{
	SC_HANDLE sch,ssch;
	char curfilepath[256];
	GetModuleFileName(NULL,curfilepath,256);
	sch = OpenSCManager(NULL,NULL,SC_MANAGER_CREATE_SERVICE);
	if (! (ssch = CreateService(sch,myservicename,myservicename,SERVICE_ALL_ACCESS,SERVICE_WIN32_SHARE_PROCESS,
		          SERVICE_AUTO_START,SERVICE_ERROR_NORMAL,curfilepath,NULL,NULL,NULL,NULL,NULL))
		)
	{
		printf("error # %d while Creating Service\n",GetLastError());
		return 0;
	}
	else printf("service create ok\n");
	CloseServiceHandle(ssch);

	return 0;
}

int UninstallThisService()
{
	SC_HANDLE sch,ssch;
	sch = OpenSCManager(NULL,NULL,SC_MANAGER_CREATE_SERVICE);
	if ((ssch = OpenService(sch,myservicename,DELETE)) == NULL)
	{
		printf("error # %d while Open Service \"%s\" for delete\n",GetLastError(),myservicename);
		return 0;
	}
	if (DeleteService(ssch) == NULL) printf("error # %d while delete service failed\n",GetLastError());
	else printf("service delete ok\n");

	return 0;
}
